--
-- fastgrowth
-- 
-- 
--
-- Dennion 02.11.2016
-- V1.0 Grundsteinlegung
-- V1.1 BackupFiles

fastgrowth = {};
addModEventListener(fastgrowth);
function fastgrowth.prerequisitesPresent(specializations)
    return true;
end;

function fastgrowth:loadMap(name)
	-- #### Savegame Ordner herrausfinden Idee: JakobT (Modhoster)
	if g_server ~= nil then
		local fastgrowth_savegameDir;
		if g_currentMission.missionInfo.savegameDirectory then
			fastgrowth_savegameDir = g_currentMission.missionInfo.savegameDirectory;
		end;
		if not fastgrowth_savegameDir and g_careerScreen.currentSavegame and g_careerScreen.currentSavegame.savegameIndex then 
			fastgrowth_savegameDir = ('%ssavegame%d'):format(getUserProfileAppPath(), g_careerScreen.currentSavegame.savegameIndex);
		end;
		if not fastgrowth_savegameDir and g_currentMission.missionInfo.savegameIndex ~= nil then
			fastgrowth_savegameDir = ('%ssavegame%d'):format(getUserProfileAppPath(), g_careerScreen.missionInfo.savegameIndex);
		end;
		-- Definition der Ordnerstruktur
		savegameFolderPath = fastgrowth_savegameDir;
		-- Definition des genauen Dateiverzeichniss
		self.fastgrowthXML = savegameFolderPath .. '/Fastgrowth_config.xml';
	end
	fastgrowth.Config = fastgrowth:loadXMLConfig() -- Config XML Laden
	FruitUtil.fruitTypeGrowths["wheat"].growthStateTime = fastgrowth.Config.wheat*3600000; -- Weizen
    FruitUtil.fruitTypeGrowths["rape"].growthStateTime = fastgrowth.Config.rape*3600000;  -- Raps
    FruitUtil.fruitTypeGrowths["barley"].growthStateTime = fastgrowth.Config.barley*3600000; -- Gerste
    FruitUtil.fruitTypeGrowths["maize"].growthStateTime = fastgrowth.Config.maize*3600000;  -- Mais
    FruitUtil.fruitTypeGrowths["potato"].growthStateTime = fastgrowth.Config.potato*3600000; -- Kartoffeln
    FruitUtil.fruitTypeGrowths["sugarBeet"].growthStateTime = fastgrowth.Config.sugarBeet*3600000; -- Zuckerrüben
    FruitUtil.fruitTypeGrowths["sunflower"].growthStateTime = fastgrowth.Config.sunflower*3600000;  -- Sonneblumen
    FruitUtil.fruitTypeGrowths["soybean"].growthStateTime = fastgrowth.Config.soybean*3600000;  -- Sojabohnen
    FruitUtil.fruitTypeGrowths["oilseedRadish"].growthStateTime = fastgrowth.Config.oilseedRadish*3600000; -- Ölpflanzen Wie auch immer die heißen :D
    FruitUtil.fruitTypeGrowths["poplar"].growthStateTime = fastgrowth.Config.poplar*3600000; -- ??? Find ich noch herraus :D
    FruitUtil.fruitTypeGrowths["grass"].growthStateTime = fastgrowth.Config.grass*3600000;  --  Grass
	print("--- fast growth V1.0 geladen --- (von Dennion)")
end;

function fastgrowth:deleteMap()
	
end

function fastgrowth:loadXMLConfig()
	
	
	local file = fastgrowth.fastgrowthXML;	
	local ConfigXml;
	local res = {};
	
	if fileExists(file) then
		
		ConfigXml = loadXMLFile("FAST_GROWTH_XML", file, "FASTGROWTH");
		print(""..file.." wurde geladen!");	
	else --create std file instead:
		ConfigXml = createXMLFile("FAST_GROWTH_XML", file, "FASTGROWTH");
		print(""..file.." wurde erstellt");
		res.wheat = 3;
		res.rape = 3;
		res.barley = 3;
		res.maize = 3;
		res.potato = 3;
		res.sugarBeet = 3;
		res.sunflower = 3;
		res.soybean = 3;
		res.oilseedRadish = 3;
		res.poplar = 3;
		res.grass = 3;
		
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.wheat",res.wheat);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.rape",res.rape);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.barley",res.barley);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.maize",res.maize);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.potato",res.potato);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.sugarBeet",res.sugarBeet);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.sunflower",res.sunflower);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.soybean",res.soybean);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.oilseedRadish",res.oilseedRadish);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.poplar",res.poplar);
		setXMLInt(ConfigXml, "FASTGROWTH.fruit.grass",res.grass);
		saveXMLFile(ConfigXml);
		return res;
	end;
	if ConfigXml ~= nil then	
		res.wheat = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.wheat");
		res.rape = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.rape");
		res.barley = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.barley");
		res.maize = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.maize");
		res.potato = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.potato");
		res.sugarBeet = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.sugarBeet");
		res.sunflower = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.sunflower");
		res.soybean = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.soybean");
		res.oilseedRadish = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.oilseedRadish");
		res.poplar = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.poplar");
		res.grass = getXMLFloat(ConfigXml, "FASTGROWTH.fruit.grass");
	end;
	return res;
end;

function fastgrowth:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fastgrowth:keyEvent(unicode, sym, modifier, isDown)
end;

function fastgrowth:update()
	
end

function fastgrowth:draw()
   
end;

-- ~~~~~ Backup Erstellen und Laden | Idee: JakobT ModHoster
function fastgrowth:backupFG(self)
	local fastgrowth_savegameFolder = g_currentMission.missionInfo.savegameDirectory;
	if g_server == nil and g_dedicatedServerInfo == nil then return end;
	if not fileExists(fastgrowth.fastgrowthXML) then
		return;
	end;
	local savegameID = g_currentMission.missionInfo.savegameIndex;
	-- Definiere Temporären Ordner für Backup
	fastgrowth.TempSavegameFolder = getUserProfileAppPath() .. 'fastgrowthBackupSG' .. savegameID;
	-- Erstelle Ordner für Backup
	createFolder(fastgrowth.TempSavegameFolder);
	-- Definiere Ort für Backup Datei
	fastgrowth.BackupPath = fastgrowth.TempSavegameFolder .. '/Fastgrowth_config.xml';
	-- Kopiere Originale Datei aus Savegame ns Backup Verzeichniss
	copyFile(fastgrowth.fastgrowthXML, fastgrowth.BackupPath, true);
end;
g_careerScreen.saveSavegame = Utils.prependedFunction(g_careerScreen.saveSavegame, fastgrowth.backupFG);

function fastgrowth:getFGBackupBack(self)
	if g_server == nil and g_dedicatedServerInfo == nil then return end;
	if not fastgrowth.BackupPath then return end;

	local savegameID = g_currentMission.missionInfo.savegameIndex;
	local savegameFolder = g_currentMission.missionInfo.savegameDirectory or fastgrowth.savegameFolder;
	if savegameFolder == nil then
		savegameFolder = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameID);
	end;
	-- Prüfen ob Karrieredatei vorhanden
	if fileExists(savegameFolder .. '/careerSavegame.xml') then 
		-- Backup Datei wieder in das Savegame kopieren
		copyFile(fastgrowth.BackupPath, fastgrowth.fastgrowthXML, true);
		-- Backup Phad wieder Nullen
		fastgrowth.BackupPath = nil;
	else 
		-- Keine Karrieredatei gefunden... Sollte eig nicht vorkommen
		print(('ERROR: A Backup from your Fast Growth File can you find on: %q'):format(fastgrowth.cpTempSaveFolderPath));
	end;
end;
g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, fastgrowth.getFGBackupBack);
